/*
 * Copyright (c) CompanyNameMagicTag 2022-2023. All rights reserved.
 * Description: ebai ioctl
 */

#ifndef EBAI_IOCTL_H
#define EBAI_IOCTL_H

#include <linux/ioctl.h>

#define EBAI_DIR_IOC(dir, type, nr, param)		_IO##dir(EBAI_IOC_##type, nr, param)
#define EBAI_IOC(type, nr)						_IO(EBAI_IOC_##type, nr)
#define EBAI_DISPLAY_DIR_IOC(dir, nr, param)	EBAI_DIR_IOC(dir, DISPLAY, nr, param)
#define EBAI_CPU_DIR_IOC(dir, nr, param)		EBAI_DIR_IOC(dir, CPU, nr, param)
#define EBAI_GPU_DIR_IOC(dir, nr, param)		EBAI_DIR_IOC(dir, GPU, nr, param)
#define EBAI_SENSORHUB_DIR_IOC(dir, nr, param)	EBAI_DIR_IOC(dir, SENSORHUB, nr, param)
#define EBAI_BATTERY_DIR_IOC(dir, nr, param)	EBAI_DIR_IOC(dir, BATTERY, nr, param)
#define EBAI_UTILS_DIR_IOC(dir, nr, param)		EBAI_DIR_IOC(dir, UTILS, nr, param)
#define EBAI_SR_DIR_IOC(dir, nr, param)			EBAI_DIR_IOC(dir, SR, nr, param)
#define EBAI_MISC_DIR_IOC(dir, nr, param)		EBAI_DIR_IOC(dir, MISC, nr, param)
#define EBAI_DDR_DIR_IOC(dir, nr, param)		EBAI_DIR_IOC(dir, DDR, nr, param)
#define EBAI_PERI_DIR_IOC(dir, nr, param)		EBAI_DIR_IOC(dir, PERI, nr, param)

enum ebai_ioctl_type_t {
	EBAI_IOC_DISPLAY = 0,
	EBAI_IOC_CPU = 1,
	EBAI_IOC_GPU = 2,
	EBAI_IOC_SENSORHUB = 3,
	EBAI_IOC_BATTERY = 4,
	EBAI_IOC_UTILS = 5,
	EBAI_IOC_SR = 6,
	EBAI_IOC_MISC = 7,
	EBAI_IOC_DDR = 8,
	EBAI_IOC_PERI = 9,
};

#endif // EBAI_IOCTL_H
