/*
 * Copyright (c) CompanyNameMagicTag 2021. All rights reserved.
 * Description: Bl31 hibernate Header files
 * Author : AuthorNameMagicTag
 * Create : 2021/4/10
 */

#ifndef BL31_HIBERNATE_H
#define BL31_HIBERNATE_H

struct hibernate_meminfo_t {
	/* pyhs addr of kernel and bl31 share memory */
	phys_addr_t paddr;
	/* addr size of kernel and bl31 share memory */
	u64 addr_size;
	/* virt addr of kernel memory for kernel management */
	void *kmem_vaddr;
};

#ifdef CONFIG_BL31_HIBERNATE
int bl31_hibernate_freeze(void);
int bl31_hibernate_restore(void);
struct hibernate_meminfo_t *get_bl31_hibernate_mem_info(void);
#else
static inline int bl31_hibernate_freeze(void)
{
	return 0;
}

static inline int bl31_hibernate_restore(void)
{
	return 0;
}

static inline struct hibernate_meminfo_t *get_bl31_hibernate_mem_info(void)
{
	return NULL;
}
#endif

#endif /* BL31_HIBERNATE_H */
