/*
 * Copyright (c) CompanyNameMagicTag 2021. All rights reserved.
 * Description: Bl31 LOG Header files
 * Author : AuthorNameMagicTag
 * Create : 2021/09/06
 */

#ifndef BL31_LOG_H
#define BL31_LOG_H

#ifdef CONFIG_KERNEL_BL31_LOG
unsigned int bl31_log_size_get(void);
int bl31_logbuf_read(const char *read_buf, unsigned int buf_size);
int bl31_log_init(struct dentry *dir);
#else
static int bl31_log_init(struct dentry *dir)
{
	return 0;
}

static inline unsigned int bl31_log_size_get(void)
{
	return 0;
}

static inline int bl31_logbuf_read(const char *read_buf, unsigned int buf_size)
{
	return -1;
}
#endif

#endif /* BL31_LOG_H */
