/*
 * Copyright (c) CompanyNameMagicTag 2022-2023. All rights reserved.
 * Description: This interface is provided by the drv_ion for the upper layer to invoke.
 * Author: AuthorNameMagicTag
 * Create: 2022-06-30
 */
#ifndef _MEDIA_MEM_ION_H
#define _MEDIA_MEM_ION_H

#include <linux/types.h>
#include <linux/dma-buf.h>
#include <linux/ion.h>

struct media_mem_ops {
	int (*mma_ioctl)(unsigned int, void *);
	void* (*mma_init_media_mem)(void *, const char *, unsigned int, const void *, size_t);
	void (*mma_deinit_media_mem)(void *);
};

int mma_ion_pools_init(void);
void mma_ion_set_pool_by_head(struct ion_heap *heap);
struct ion_heap *mma_ion_cma_heap_create(struct cma *cma);
struct ion_heap *mma_ion_system_heap_create(void);
struct ion_device *get_ion_device(void);
int ion_alloc_dmabuf(size_t len, unsigned int heap_id_mask, unsigned int flags, struct dma_buf **pdmabuf);
int is_ion_dma_buf(struct dma_buf *dmabuf);

#endif

