/*
 * Copyright (c) @CompanyNameMagicTag 2020. All rights reserved.
 */
#ifndef __MNTN_DUMP_H
#define __MNTN_DUMP_H
#include <mntn/platform/mntn_public_interface.h>

/* bit32 31: reserve:   max value is 0x20000000 */
#define SYS_SUBSYS_NUMS_MAX 31
enum SUBSYS_ID {
	SYS_SUBSYS_BBOX = 0x1,
	SYS_SUBSYS_PROC = 0x2,
	SYS_SUBSYS_TEE = 0x4,
	SYS_SUBSYS_HIFI = 0x8,
	SYS_SUBSYS_MAX = SYS_SUBSYS_HIFI
};

/*
 * func name: pfn_subsys_cb
 * func args:
 *    int subsys_id: subsys index
 *    int result: true or false
 * return value null
 */

typedef void (*pfn_subsys_cb) (enum SUBSYS_ID subsys_id, int result);

/*
 * func name: pfn_module_dump
 * func args:
 *    int subsys_id: subsys index
 *    char *logpath:  save log path
 *    pfn_subsys_cb cb :  save log done,  call cb notify mntn
 *    char *reserve:  reserve buffer,
 * return value null
 */
typedef void (*pfn_subsys_dump)(enum SUBSYS_ID subsys_id, const char *logpath, pfn_subsys_cb cb, const char *reserve);

#ifdef CONFIG_MNTN_SYSLOG
int mntn_register_syslogs_ops(enum SUBSYS_ID subsys_id, pfn_subsys_dump ops, const char *reserve);

int mntn_unregister_syslogs_ops(enum SUBSYS_ID subsys_id);

#else
static inline int mntn_register_syslogs_ops(enum SUBSYS_ID subsys_id,
	pfn_subsys_dump ops, const char *reserve)
{
	return 0;
}
static inline int mntn_unregister_syslogs_ops(enum SUBSYS_ID subsys_id)
{
	return 0;
}
#endif

#ifdef CONFIG_PLATFORM_MAINTAIN
extern int register_mntn_dump(int mod_id, unsigned int size, void **vaddr);
void register_pstore_to_mntndump(char *big_oops_buf, size_t big_oops_buf_sz);

#else
static inline int register_mntn_dump(int mod_id, unsigned int size, void **vaddr)
{
	return -1;
}
static inline void register_pstore_to_mntndump(char *big_oops_buf, size_t big_oops_buf_sz)
{
	return;
}
#endif

#endif
