/*
 * Copyright (c) @CompanyNameMagicTag 2020. All rights reserved.
 */
#ifndef __BBOX_DIAGINFO_ID_DEF_H__
#define __BBOX_DIAGINFO_ID_DEF_H__

/* diaginfo ID :  925200000 -- 925299999 */
enum bbox_diaginfo_errid {
	SOC_DIAGINFO_START = 925200000, /* start ID */
	L3_ECC_1BIT_ERROR = SOC_DIAGINFO_START,  /* l3 cache is 1bit error, ID:925200000  */
	CPU_UP_FAIL,   /* CPU UP fail, ID:925200001  */
	CPU_PANIC_INFO,
	NOC_FAULT_INFO,
	L3_ECC_2BIT_ERROR = 925201200,
	L3_ECC_BUS_ERROR,

	/* sensorhub module start: 925201600  */
	IOMCU_DIAG_INFO_HW_START = 925201600,
	SWING_DMD_FDUL_PW_ON = IOMCU_DIAG_INFO_HW_START,   /* 925201600 */
	SWING_DMD_FDUL_PW_OFF = 925201601,            /* 925201601 */
	SWING_DMD_HWTS_PW_ON = 925201602,             /* 925201602 */
	SWING_DMD_HWTS_PW_OFF = 925201603,            /* 925201603 */
	SWING_DMD_AIC_PW_ON = 925201604,              /* 925201604 */
	SWING_DMD_AIC_PW_OFF = 925201605,             /* 925201605 */

	SWING_DMD_CAM_PW_ON = 925201608,              /* 925201608 */
	SWING_DMD_CAM_PW_OFF = 925201609,             /* 925201609 */
	SWING_DMD_CAM_IR_PW = 925201610,              /* 925201610 */
	SWING_DMD_CAM_TIMEOUT = 925201611,            /* 925201611 */
	IOMCU_DIAG_INFO_HW_END = 925201699,

	IOMCU_DIAG_INFO_SW_START = 925201700,
	SWING_DMD_SLEEP_FUSION = 925201714,    /* 925201714 */
	IOMCU_DIAG_INFO_SW_END = 925201899,

	IOMCU_DIAG_INFO_MONITER_START = 925201900,
	IOMCU_DIAG_INFO_MONITER_END = 925201959,

	IOMCU_DIAG_INFO_RESERVED_START = 925201960,
	IOMCU_DIAG_INFO_RESERVED_END = 925201999,
	/* sensorhub module end: 925201999 */

	/* DDR module   */
	DDR_DIAGINFO_START = 925202000,
	LPM3_DDR_FAIL = DDR_DIAGINFO_START,

	BBOX_DIAGINFO_END = 925299999
};

/* module(DMD device ) define */
enum bbox_diaginfo_module {
	SOC_AP = 1, /* SoC AP */
	DSS,  /* Display */
	DDR, /* DDR */
	FDUL, /* FDUL */
};

/* info level define */
enum bbox_diaginfo_level {
	CRITICAL = 1, /* critical */
	WARNING,  /* warning */
	INFO, /* info */
};

/* diaginfo type */
enum bbox_diaginfo_type {
	HW = 1, /* hardware */
	SW,  /* software */
};

#endif /* __BBOX_DIAGINFO_ID_DEF_H__ */
