/*
 * Copyright (c) @CompanyNameMagicTag 2020. All rights reserved.
 */
#ifndef __MNTN_REBOOT_REASON_MAP_H__
#define __MNTN_REBOOT_REASON_MAP_H__

#include "mntn_public_interface.h"
#include "mntn_subtype_exception.h"
#ifndef __reboot_reason_map
#define __reboot_reason_map(x, y)
#endif
__reboot_reason_map(AP_S_COLDBOOT, NORMALBOOT)
__reboot_reason_map(BOOT_LOADER, NORMALBOOT)
__reboot_reason_map(RECOVERY, NORMALBOOT)
__reboot_reason_map(FASTBOOTD, NORMALBOOT)
__reboot_reason_map(RESET_UART, NORMALBOOT)
__reboot_reason_map(AT2_RESET_FACTORY, NORMALBOOT)
__reboot_reason_map(ATF_FACTORY_RESET0, NORMALBOOT)
__reboot_reason_map(RESET_USER, NORMALBOOT)
__reboot_reason_map(SD_UPDATE, NORMALBOOT)
__reboot_reason_map(CHARGE_REBOOT, NORMALBOOT)
__reboot_reason_map(RESIZE, NORMALBOOT)
__reboot_reason_map(ERECOVERY, NORMALBOOT)
__reboot_reason_map(USB_UPDATE, NORMALBOOT)
__reboot_reason_map(CUST, NORMALBOOT)
__reboot_reason_map(AP_S_S4_COLDBOOT, NORMALBOOT)
__reboot_reason_map(OEM_RTC, NORMALBOOT)
__reboot_reason_map(UNKNOWN, NORMALBOOT)
__reboot_reason_map(MOUNT_FAIL, NORMALBOOT)
__reboot_reason_map(HUNG_DETECT, NORMALBOOT)
__reboot_reason_map(COLDBOOT, NORMALBOOT)
__reboot_reason_map(UPDATE_DATA_IMG, NORMALBOOT)
__reboot_reason_map(AP_S_FASTBOOTFLASH, NORMALBOOT)
__reboot_reason_map(AP_S_PRESS6S, PRESS6S)
__reboot_reason_map(GPS_COLD_BOOT, NORMALBOOT)
__reboot_reason_map(AP_S_ABNORMAL, UNKNOWN)
__reboot_reason_map(AP_S_TSENSOR0, HARDWARE_FAULT)
__reboot_reason_map(AP_S_TSENSOR1, HARDWARE_FAULT)
__reboot_reason_map(AP_S_TSENSOR2, HARDWARE_FAULT)
__reboot_reason_map(AP_S_AWDT, SUBTYPE)
__reboot_reason_map(CHARGER_S_WDT, HWWATCHDOG)
__reboot_reason_map(G3D_S_G3DTSENSOR, HARDWARE_FAULT)
__reboot_reason_map(CP_S_CPTSENSOR, HARDWARE_FAULT)
__reboot_reason_map(IOM3_S_IOMCURST, SENSORHUBCRASH)
__reboot_reason_map(ASP_S_ASPWD, HIFICRASH)
__reboot_reason_map(CP_S_CPWD, MODEM_REBOOTSYS)
__reboot_reason_map(IVP_S_IVPWD, IVPCRASH)
__reboot_reason_map(ISP_S_ISPWD, ISPCRASH)
__reboot_reason_map(AP_S_DDR_UCE_WD, HARDWARE_FAULT)
__reboot_reason_map(AP_S_DDR_FATAL_INTER, HARDWARE_FAULT)
__reboot_reason_map(OCBC_S_WD, HWWATCHDOG)
__reboot_reason_map(AP_S_PANIC, SUBTYPE)
__reboot_reason_map(AP_S_NOC, PANIC)
__reboot_reason_map(AP_S_RESUME_SLOWY, PANIC)
__reboot_reason_map(AP_S_DDRC_SEC, PANIC)
__reboot_reason_map(AP_S_F2FS, PANIC)
__reboot_reason_map(AP_S_COMBINATIONKEY, NORMALBOOT)
__reboot_reason_map(AP_S_BL31_PANIC, SUBTYPE)
__reboot_reason_map(AP_S_MAILBOX, PANIC)
__reboot_reason_map(AP_S_HHEE_PANIC, PANIC)
__reboot_reason_map(AP_S_SUBPMU, HARDWARE_FAULT)
__reboot_reason_map(AP_S_VENDOR_PANIC, SUBTYPE)
__reboot_reason_map(AP_S_OOM, PANIC)
__reboot_reason_map(AP_S_STANDBY, SUBTYPE)
__reboot_reason_map(AP_S_CRASH, SUBTYPE)
__reboot_reason_map(AP_S_MMA, SUBTYPE)
__reboot_reason_map(AP_S_SIMULATOR, NORMALBOOT)
__reboot_reason_map(WIFI_S_EXCEPTION, CONNEXCEPTION)
__reboot_reason_map(CP_S_MODEMDMSS, MODEM_REBOOTSYS)
__reboot_reason_map(LPM3_S_EXCEPTION, SUBTYPE)
__reboot_reason_map(SOCHIFI_S_EXCEPTION, SUBTYPE)
__reboot_reason_map(AUDIO_CODEC_EXCEPTION, AUDIO_CODEC_CRASH)
__reboot_reason_map(DDRWZ_S_EXCEPTION, PANIC)
__reboot_reason_map(HIFI_S_RESETFAIL, HIFICRASH)
__reboot_reason_map(ISP_S_EXCEPTION, ISPCRASH)
__reboot_reason_map(IVP_S_EXCEPTION, IVPCRASH)
__reboot_reason_map(IOM3_S_EXCEPTION, SENSORHUBCRASH)
__reboot_reason_map(TEE_S_EXCEPTION, TRUSTZONECRASH)
__reboot_reason_map(MMC_S_EXCEPTION, SUBTYPE)
__reboot_reason_map(CODECHIFI_S_EXCEPTION, HIFICRASH)
__reboot_reason_map(IOM3_S_USER_EXCEPTION, NORMALBOOT)
__reboot_reason_map(OUTSEE_S_EXCEPTION, SUBTYPE)
__reboot_reason_map(NPU_S_EXCEPTION, SUBTYPE)
__reboot_reason_map(BFGX_S_EXCEPTION, SUBTYPE)
__reboot_reason_map(WIFI_S_EXCEPTION, SUBTYPE)
__reboot_reason_map(AP_S_PMU, HARDWARE_FAULT)
__reboot_reason_map(AP_S_SMPL, HARDWARE_FAULT)
__reboot_reason_map(AP_S_AHBTIMEOUT, HARDWARE_FAULT)
__reboot_reason_map(AP_S_SCHARGER, HARDWARE_FAULT)
__reboot_reason_map(BR_UPDATE_USB, NORMALBOOT)
__reboot_reason_map(BR_UPDATA_SD_FORCE, NORMALBOOT)
__reboot_reason_map(BR_KEY_VOLUMN_UP, NORMALBOOT)
__reboot_reason_map(BR_PRESS_1S, NORMALBOOT)
__reboot_reason_map(BR_PRESS_10S, PRESS10S)
__reboot_reason_map(BR_CHECK_RECOVERY, NORMALBOOT)
__reboot_reason_map(BR_CHECK_ERECOVERY, NORMALBOOT)
__reboot_reason_map(BR_CHECK_SDUPDATE, NORMALBOOT)
__reboot_reason_map(BR_CHECK_USBUPDATE, NORMALBOOT)
__reboot_reason_map(BR_CHECK_RESETFACTORY, NORMALBOOT)
__reboot_reason_map(BR_CHECK_HOTAUPDATE, NORMALBOOT)
__reboot_reason_map(BR_POWERONNOBAT, NORMALBOOT)
__reboot_reason_map(BR_NOGUI, NORMALBOOT)
__reboot_reason_map(BR_FACTORY_VERSION, NORMALBOOT)
__reboot_reason_map(BR_RESET_HAPPEN, NORMALBOOT)
__reboot_reason_map(BR_POWEROFF_ALARM, NORMALBOOT)
__reboot_reason_map(BR_POWEROFF_CHARGE, NORMALBOOT)
__reboot_reason_map(BR_POWERON_BY_SMPL, NORMALBOOT)
__reboot_reason_map(BR_CHECK_UPDATEDATAIMG, NORMALBOOT)
__reboot_reason_map(BR_REBOOT_CPU_BUCK, HARDWARE_FAULT)
__reboot_reason_map(BR_L2_CACHE_FAIL, HARDWARE_FAULT)
__reboot_reason_map(BR_POWERON_CHARGE, NORMALBOOT)
__reboot_reason_map(SBL_S_PANIC, BOOTLOADER_CRASH)
__reboot_reason_map(SBL_S_CUSTOMINIT_FAIL, BOOTLOADER_CRASH)
__reboot_reason_map(SBL_S_VERIFY_IMG_ERR, BOOTLOADER_CRASH)
__reboot_reason_map(SBL_S_BOARDID_FAIL, BOOTLOADER_CRASH)
__reboot_reason_map(SBL_S_MEDIAINIT_FAIL, HARDWARE_FAULT)
__reboot_reason_map(UEFI_S_WATCHDOG, BOOTLOADER_CRASH)
__reboot_reason_map(UEFI_S_PANIC, BOOTLOADER_CRASH)
__reboot_reason_map(UEFI_S_GOP_FAIL, SUBTYPE)
__reboot_reason_map(UEFI_S_GMAC_FAIL, BOOTLOADER_CRASH)
__reboot_reason_map(UEFI_S_PCIE_FAIL, BOOTLOADER_CRASH)
__reboot_reason_map(UEFI_S_UPGRADE_FAIL, SUBTYPE)
__reboot_reason_map(UEFI_S_USB_FAIL, BOOTLOADER_CRASH)
__reboot_reason_map(UEFI_S_SATA_FAIL, BOOTLOADER_CRASH)
__reboot_reason_map(BFM_S_NATIVE_BOOT_FAIL, BOOTFAIL)
__reboot_reason_map(BFM_S_BOOT_TIMEOUT, BOOTFAIL)
__reboot_reason_map(BFM_S_FW_BOOT_FAIL, BOOTFAIL)
__reboot_reason_map(BFM_S_NATIVE_DATA_FAIL, BOOTFAIL)
#endif
