/*
 * Copyright (c) @CompanyNameMagicTag 2020. All rights reserved.
 */

#ifndef __MNTN_SUBTYPE_EXCEPTION_H__
#define __MNTN_SUBTYPE_EXCEPTION_H__

enum mmc_exception_subtype {
	MMC_EXCEPT_INIT_FAIL = 0x0,
	MMC_EXCEPT_CMD_TIMEOUT,
	MMC_EXCEPT_COLDBOOT,
};
enum appanic_subtype {
	SUB_APPANIC_RESERVED = 0x0,
	SUB_APPANIC_BC_PANIC = 0x1,
	SUB_APPANIC_L3CACHE_ECC1 = 0x2,
	SUB_APPANIC_SOFTLOCKUP = 0x3,
	SUB_APPANIC_OHARDLOCKUP = 0x4,
	SUB_APPANIC_HARDLOCKUP = 0x5, /* sp805 detector hardlockup */
	SUB_APPANIC_SP805_WDG = 0x6,
	SUB_APPANIC_L3CACHE_ECC2 = 0x7,
	SUB_APPANIC_STORAGE = 0x8,
	SUB_APPANIC_ISP = 0x9,
	SUB_APPANIC_IVP = 0xa,
	SUB_APPANIC_GPU = 0xc,
	SUB_APPANIC_DVFS = 0xd,
};
enum apstandby_subtype {
	SUB_APSTANDBY_S3_SUSPEND = 0x0,
	SUB_APSTANDBY_S3_RESUME  = 0x1,
	SUB_APSTANDBY_S4_FREEZE  = 0x2,
	SUB_APSTANDBY_S4_THAW    = 0x3,
	SUB_APSTANDBY_S4_RESTORE = 0x4,
	SUB_APSTANDBY_SUSPEND = 0x5,
	SUB_APSTANDBY_RESUME = 0x6,
};

enum apcrash_subtype {
	KASAN_UNKNOWN_CRASH = 0x0,
	KASAN_OUT_OF_BOUNDS = 0x1,
	KASAN_USE_AFTER_FREE  = 0x2,
	KASAN_USE_AFTER_SCOPE = 0x3,
	KASAN_NULL_PTR_EDREF = 0x4,
	KASAN_USER_MEM_ACC = 0x5,
	KASAN_WILD_MEM_ACC = 0x6,
	KASAN_DOUBLE_FREE = 0x7,
	SUB_AP_ATOMIC_SLEEP = 0x8,
	SUB_AP_LOCK_ERR = 0x9,
	SUB_AP_LOCKDEP = 0xA,
	SUB_AP_UBSAN = 0xB,
};

enum mmacrash_subtype {
	SUB_AP_MMA_CRASH     = 0x0,
	SUB_AP_MMA_ALLOC_ERR = 0x1,
	SUB_AP_MMA_FREE_ERR  = 0x2,
	SUB_AP_MMA_MAP_ERR   = 0x3,
	SUB_AP_MMA_REF_ERR   = 0x4,
};

enum uefi_gop_subtype {
	SUB_GOP_COMM_FAIL = 0x0,
	SUB_GOP_XDP_FAIL  = 0x1,
	SUB_GOP_GFX_FAIL  = 0x2,
	SUB_GOP_OUTPORT_FAIL    = 0x3,
	SUB_GOP_EXTERNAL_FAIL = 0x4,
	SUB_GOP_APP_FAIL = 0x5,
};

enum uefi_upgrade_subtype {
	SUB_UPGRADE_COMM_FAIL = 0x0,
	SUB_UPGRADE_PKG_FAIL  = 0x1,
};

enum apbl31panic_subtype {
	SUB_APBL31PANIC_RESERVED = 0x0,
	SUB_APBL31PANIC_ASSERT = 0x1,
};
enum apvndpanic_subtype {
	SUB_APVNDPANIC_RESERVED = 0x0,
	SUB_APVNDPANIC_CFI = 0x1,
};
enum apwdt_subtype {
	SUB_APWDT_HW = 0x0,
	SUB_APWDT_LPM3 = 0x1,
	SUB_APWDT_BL31 = 0x2,
	SUB_APWDT_BL31LPM3 = 0x3,
	SUB_APWDT_AP = 0x4,
	SUB_APWDT_BL31AP = 0x6,
	SUB_APWDT_APBL31LPM3 = 0x7,
	SUB_APWDT_AP_SEC = 0x8,
	SUB_APWDT_AP_ECS = 0x9,
};

enum mem_repair_subtype {
	OMR_PASS_REBOOT = 0x1,
	OMR_REPAIR_FAIL = 0x2,
	OMR_RETEST_FAIL = 0x3,
};
enum conn_subtype {
	CONN_WIFI_EXEC = 0,
	CONN_WIFI_CHAN_EXEC,
	CONN_WIFI_WAKEUP_FAIL,
	CONN_BFGX_EXEC,
	CONN_BFGX_BEAT_TIMEOUT,
	CONN_BFGX_WAKEUP_FAIL,
};

enum hifi_subtype {
	HIFI_OVERFLOW = 0,
};

typedef enum {
	CATEGORY_START = 0x0,
	NORMALBOOT,
	PANIC,
	APCRASH,
	HWWATCHDOG,
	BOOTLOADER_CRASH,
	SLAVEBOOT_CRASH,
	TRUSTZONE_REBOOTSYS,
	MODEM_REBOOTSYS,
	BOOTFAIL,
	HARDWARE_FAULT,
	MODEMCRASH,
	HIFICRASH,
	AUDIO_CODEC_CRASH,
	SENSORHUBCRASH,
	ISPCRASH,
	IVPCRASH,
	TRUSTZONECRASH,
	OUTSEECRASH,
	UNKNOWNS,
	PRESS10S,
	PRESS6S,
	NPUEXCEPTION,
	CONNEXCEPTION,
	SIMULATOR,
	SUBTYPE = 0xff,
}gategory_source;
struct exp_subtype {
	unsigned int exception;
	unsigned char category_name[24]; /* 24 name length */
	unsigned char subtype_name[24];  /* 24 name length */
	unsigned int subtype_num;
};

#endif
