/*
 * Copyright (c) @CompanyNameMagicTag 2020. All rights reserved.
 */

#ifndef __RDR_HW_DIAG_H__
#define __RDR_HW_DIAG_H__

#include <mntn/mntn_bbox_diaginfo.h>

#define RDR_HWDIAG_TRACE_DATA_MAXLEN 128

struct rdr_diag_noc_info {
	char *init_flow;
	char *target_flow;
};

struct rdr_diag_panic_info {
	unsigned int cpu_num;
};

typedef union {
	struct rdr_diag_noc_info noc_info;
	struct rdr_diag_panic_info cpu_info;
} rdr_hw_diag_info;

struct rdr_hw_diag_trace {
	unsigned int used;
	unsigned int err_id;
	char data[RDR_HWDIAG_TRACE_DATA_MAXLEN];
};

struct rdr_hw_diag_dev {
	spinlock_t record_lock;
	struct rdr_hw_diag_trace *trace_addr;
	unsigned int trace_size;
	unsigned int trace_max_num;
};

#ifdef CONFIG_MNTN_HW_DIAG
void rdr_hw_diaginfo_trace(unsigned int err_id, rdr_hw_diag_info *diaginfo);
void rdr_hw_diaginfo_record(const char *date);
void rdr_hw_diag_init(void);
#else
static inline void rdr_hw_diaginfo_trace(unsigned int err_id, rdr_hw_diag_info *diaginfo)
{
	return;
}
static inline void rdr_hw_diaginfo_record(const char *date)
{
	return;
}
static inline void rdr_hw_diag_init(void)
{
	return;
}
#endif

#endif
