/*
 * Copyright (c) @CompanyNameMagicTag 2020. All rights reserved.
 */

#ifndef __RDR_LOG_H__
#define __RDR_LOG_H__

#include <linux/atomic.h>

#define RDR_PBUF_MAXSIZE (256 + 44) /* common :256  time:44 */
#define LAST_BOOT_LOG_NAME "last_"
#define CURRENT_LOG_NAME "current_"
#define NORMAL_LOG_NAME "messages_"

#ifdef CONFIG_MNTN_EXTENDLOG
void rdr_print_to_file(const char *fmt, ...);

int rdr_log_thread_body(void *arg);
void rdr_register_extend_request(const char *log_path, const char *file_name, bool flush);

#else
static inline void rdr_print_to_file(const char *fmt, ...)
{
	return;
}
static inline int rdr_log_thread_body(void *arg)
{
	return 0;
}

static inline void rdr_register_extend_request(const char *log_path, const char *file_name, bool flush)
{
	return;
}
#endif

#endif

