/*
 * Copyright (c) @CompanyNameMagicTag 2020. All rights reserved.
 */

#ifndef __BB_PSTORE_H__
#define __BB_PSTORE_H__

#define PSTORE_BOOTCHECK_FLAG (1 << 1)
#define PSTORE_POWERON_FLAG (1 << 2)

#ifdef CONFIG_MNTN_BB
void rdr_save_pstore_log(const char *name, const int name_len, const void *data, size_t size);
void rdr_free_persist_store(int free_mid);
void save_pstore_info(const char *dst_dir);
void persist_store_mem_map(const char *name, void *vaddr);
void persist_store_mem_unmap(void);
void *persist_store_lmsg_vaddr(void);
void *persist_store_pmsg_vaddr(void);
#else
static inline void rdr_save_pstore_log(const char *name, const int name_len, const void *data, size_t size)
{
	return;
}
static inline void rdr_free_persist_store(int free_mid)
{
	return;
}

static inline void save_pstore_info(const char *dst_dir)
{
	return;
}

static inline void persist_store_mem_map(const char *name, void *vaddr)
{
	return;
}
static inline void persist_store_mem_unmap(void)
{
	return;
}
static inline void *persist_store_lmsg_vaddr(void)
{
	return NULL;
}
static inline void *persist_store_pmsg_vaddr(void)
{
	return NULL;
}
#endif

#endif /* __BB_PSTORE_H__ */
