/*
 * Copyright (c) CompanyNameMagicTag 2012-2019. All rights reserved.
 * Description: External interfaces of the devchip
 * Author: AuthorNameMagicTag
 * Create: 2022-06-30
 */

#ifndef DEVCHIP_H
#define DEVCHIP_H

#include <linux/types.h>

/*
 * Set the callback function to obtain the security-side handle by using the user-mode memory handle.
 */
#ifdef CONFIG_TEE_TZ
void set_fall_back_get_handle_info(phys_addr_t (*f)(int, unsigned int));
#else
static void set_fall_back_get_handle_info(phys_addr_t (*f)(int, unsigned int))
{
	return;
}
#endif

#endif
