/*
 * Copyright (c) CompanyNameMagicTag 2019-2020. All rights reserved.
 * Description: interface of feature license in huanglong chipset.
 */
#ifndef _EXT_LSADC_H_
#define _EXT_LSADC_H_

#ifdef __cplusplus
#if __cplusplus
extern "C" {
#endif
#endif /* __cpluscplus */

typedef struct {
	unsigned int channel_mask;          /* channel mask (bit0:channel-A, bit1:channele-B 1:enable 0:disable) */
	unsigned int active_bit;            /* active bit */
	unsigned int data_delta;            /* data delta */
	unsigned int deglitch_bypass;       /* deglitch bypass */
	unsigned int lsadc_reset;           /* lsadc reset */
	unsigned int power_down_mod;         /* power down model */
	unsigned int model_sel;             /* model sel */
	unsigned int lsadc_zero;            /* lsadc zero */
	unsigned int glitch_sample;         /* glitch sample */
	unsigned int time_scan;             /* time scan */
} ext_lsadc_param;

typedef struct {
	unsigned int channel;          /* channel mask (bit0:channel-A, bit1:channele-B 1:enable 0:disable) */
	unsigned int channel_val;
} ext_lsadc_value_param;

int ext_drv_lsadc_set_config(ext_lsadc_param *config);
int ext_drv_lsadc_get_config(ext_lsadc_param *config);
int ext_drv_lsadc_get_value(ext_lsadc_value_param *config);

#ifdef __cplusplus
#if __cplusplus
}
#endif
#endif /* __cpluscplus */

#endif /* _EXT_LSADC_H_ */

