/*
 * Copyright (c) CompanyNameMagicTag 2020-2022. All rights reserved.
 * Description: for huanglong pcie driver
 * Author: bsp
 * Create: 2020-09-22
 */

#ifndef __PCIE_HUANGLONG_EXTERNAL_H__
#define __PCIE_HUANGLONG_EXTERNAL_H__
#include <linux/pci.h>
#include <linux/types.h>

int soct_pcie_rescan_ep(u32 rc_idx);
int soct_pcie_register_linkdown_notify(int rc_id, void (*func)(void));
struct pci_dev* soct_pcie_get_rcdev_byid(u32 rc_idx);

#ifdef CONFIG_BL_PCIE_DEV_PM
struct pcie_pm_op {
	int (*power_down)(u32 rc_idx);
	int (*power_up)(u32 rc_idx);
	int (*link_up)(u32 rc_idx);
};

/* this should call before rc pm init */
int bsp_pcie_pm_ops_register(struct pcie_pm_op *pm_op_s);
#endif
#endif  /* __PCIE_HUANGLONG_EXTERNAL_H__ */

