/*
 * Copyright (c) CompanyNameMagicTag 2019-2020. All rights reserved.
 * Description: input resolve
 * Author: AuthorNameMagicTag
 * Create: 2019-05-20
 */

#ifndef INPUT_RESOLVE_H
#define INPUT_RESOLVE_H

struct keyval {
	const char *key;
	unsigned int sz_key;

	char *buf;
	unsigned int sz_buf;

#define KV_KEY_INT             1 // key=<int>
#define KV_KEY                 2 // <key>
#define KV_KEY_STR             3 // key=<string>
	int type;
	int def_val;
};

#define set_key(_key, _val, _type, _def)       \
	((void *)&(struct keyval){           \
		.key     = _key,             \
		.sz_key  = sizeof(_key) - 1, \
		.buf     = (char *)&_val,     \
		.sz_buf  = sizeof(_val),     \
		.type    = _type,            \
		.def_val = _def,             \
	})

int input_resolve(char *s, const char *ptail, struct keyval *keyval[], int nr_keyval,
		  char **parg);

#endif /* INPUT_RESOLVE_H */
